zoukankan      html  css  js  c++  java
  • Codeforces Round #307 (Div. 2) C. GukiZ hates Boxes 二分

    C. GukiZ hates Boxes
    time limit per test
    2 seconds
    memory limit per test
    256 megabytes
    input
    standard input
    output
    standard output

    Professor GukiZ is concerned about making his way to school, because massive piles of boxes are blocking his way.

    In total there are n piles of boxes, arranged in a line, from left to right, i-th pile (1 ≤ i ≤ n) containing ai boxes. Luckily, m students are willing to help GukiZ by removing all the boxes from his way. Students are working simultaneously. At time 0, all students are located left of the first pile. It takes one second for every student to move from this position to the first pile, and after that, every student must start performing sequence of two possible operations, each taking one second to complete. Possible operations are:

    1. If i ≠ n, move from pile i to pile i + 1;
    2. If pile located at the position of student is not empty, remove one box from it.

    GukiZ's students aren't smart at all, so they need you to tell them how to remove boxes before professor comes (he is very impatient man, and doesn't want to wait). They ask you to calculate minumum time t in seconds for which they can remove all the boxes from GukiZ's way. Note that students can be positioned in any manner after t seconds, but all the boxes must be removed.

    Input

    The first line contains two integers n and m (1 ≤ n, m ≤ 105), the number of piles of boxes and the number of GukiZ's students.

    The second line contains n integers a1, a2, ... an (0 ≤ ai ≤ 109) where ai represents the number of boxes on i-th pile. It's guaranteed that at least one pile of is non-empty.

    Output

    In a single line, print one number, minimum time needed to remove all the boxes in seconds.

    Examples
    input
    2 1
    1 1
    output
    4
    input
    3 2
    1 0 2
    output
    5
    input
    4 100
    3 4 5 4
    output
    5
    Note

    First sample: Student will first move to the first pile (1 second), then remove box from first pile (1 second), then move to the second pile (1 second) and finally remove the box from second pile (1 second).

    Second sample: One of optimal solutions is to send one student to remove a box from the first pile and a box from the third pile, and send another student to remove a box from the third pile. Overall, 5 seconds.

    Third sample: With a lot of available students, send three of them to remove boxes from the first pile, four of them to remove boxes from the second pile, five of them to remove boxes from the third pile, and four of them to remove boxes from the fourth pile. Process will be over in 5 seconds, when removing the boxes from the last pile is finished.

    题意:n个位置,m个学生,学生搬走一个箱子需要1s,学生从i位置走到i+1位置需要1s,a数组为第i个位置有a[i]个箱子,求学生最少需要多少时间搬完这些箱子;

    思路:二分答案t,对于m个学生,每个人都有t单位时间,让一个一个学生的时间充分利用,判断是需不需要m个学生;

    #include<bits/stdc++.h>
    using namespace std;
    #define ll long long
    #define pi (4*atan(1.0))
    #define eps 1e-14
    #define bug(x,y) cout<<"bug"<<x<<" "<<y<<endl;
    #define bug(x) cout<<"xxx "<<x<<endl;
    const int N=1e5+10,M=1e6+10,inf=2e9+10,mod=1e9+7;
    const ll INF=1e18+10;
    int n,m;
    int a[N],b[N];
    int check(ll x)
    {
        int st=1;
        ll sum=0;
        for(int i=1;i<=n;i++)
            b[i]=a[i];
        for(int i=1;i<=m;i++)
        {
            ll much=x-st;
            while(st<=n&&b[st]<=much)
            {
                much-=b[st];
                st++;
                if(much==0)break;
                much--;
            }
            if(st>n)return 1;
            b[st]-=much;
        }
        return 0;
    }
    int main()
    {
        scanf("%d%d",&n,&m);
        for(int i=1;i<=n;i++)
            scanf("%d",&a[i]);
        while(a[n]==0)n--;
        ll st=0;
        ll en=1e16,ans;
        while(st<=en)
        {
            ll mid=(st+en)>>1;
            if(check(mid))
            {
                en=mid-1;
                ans=mid;
            }
            else
                st=mid+1;
        }
        printf("%lld
    ",ans);
        return 0;
    }
  • 相关阅读:
    Ex 6_20 最优二叉搜索树..._第六次作业
    Ex 6_12 凸多边形的最优三角剖分..._第六次作业
    Ex 6_9 某个字符串处理语言提供了一个将字符串一分为二的基本操作..._第六次作业
    Ex 6_4 判断序列是否由合法单词组成..._第六次作业
    maven配置阿里云镜像时(私服设置~JEECG)
    node、npm、webpack、vue-cli傻傻分不清?
    设计模式~观察者模式和发布订阅模式的比较:
    前端~定位属性position(relative、absolute、fixed)的分析
    debounce防抖函数减少函数调用的逻辑分析(包裹上时间的外衣,在时间还没来时,kill)
    js原生滚动与使用插件better-scroll不起作用原因
  • 原文地址:https://www.cnblogs.com/jhz033/p/6416336.html
Copyright © 2011-2022 走看看